using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using TSF;
using System.Runtime.InteropServices;

namespace UILessTest
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window, TSF.ITfUIElementSink
    {

        public Window1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Xbh}l[W Wrapper Class
        /// </summary>
        CTfThreadMgr _threadMgr;
        /// <summary>
        /// UIElementSink ̃NbL[
        /// </summary>
        uint _uiElementSinkCookie = 0;

        protected override void OnInitialized(EventArgs e)
        {
            base.OnInitialized(e);

            // TSF ThreadMgr 擾
            // Ăяo񐔂 Dispose Kv
            _threadMgr = CTfThreadMgr.GetThreadMgr();

            // UIElement Sink (UIElement ɊւR[obN) o^
            // Vista ȑO܂ GUID_TFCAT_TIPCAP_UIELEMENTENABLED ɑȂ TIP ł
            // sׂł͂Ȃ
            Guid guid = typeof(ITfUIElementSink).GUID;
            _threadMgr.Source.AdviseSink(ref guid, this, out _uiElementSinkCookie);

            this.Closed += delegate
            {
                if (_threadMgr != null)
                {
                    if (_uiElementSinkCookie != 0)
                    {
                        _threadMgr.Source.UnadviseSink(_uiElementSinkCookie);
                    }
                    _threadMgr.Dispose();
                    _threadMgr = null;
                }
            };
        }

        void OnUIElement(uint UIElementId, bool onStart)
        {
            ITfUIElement uiElement = null;

            try
            {
                _threadMgr.UIElementMgr.GetUIElement(UIElementId, out uiElement);

                // RCW ɑ΂LXgœꂽC^[tFCX
                // ReleaseComObject ĂԕKv͂Ȃ
                ITfCandidateListUIElementBehavior candList = uiElement as ITfCandidateListUIElementBehavior;

                if (candList != null)
                {
                    uint count = 0;
                    string desc;
                    candList.GetDescription(out desc);
                    candList.GetCount(out count);
                    string[] candidates = new string[count];
                    for (uint index = 0; index < count; ++index)
                    {
                        candList.GetString(index, out candidates[index]);
                    }
                    this.listBox1.ItemsSource = candidates;

                    // ݑI𒆂̌Xg{bNXłI
                    uint currentIndex = 0;
                    candList.GetSelection(out currentIndex);
                    this.listBox1.SelectedIndex = (int)currentIndex;

                    //ȉ̃R[hœ̌Ił
                    //candList.SetSelection(index);
                    //candList.Finalize();
                }
            }
            finally
            {
                if (uiElement != null)
                {
                    Marshal.ReleaseComObject(uiElement);
                }
            }
        }

        #region ITfUIElementSink Members

        public void BeginUIElement(uint UIElementId, ref bool show)
        {
            // show = false Ƃ邱Ƃ UIElement \ɂȂ
            // vOϊ擾EIł悤ɂȂ
            show = false;

            OnUIElement(UIElementId, true);
        }

        public void UpdateUIElement(uint UIElementId)
        {
            OnUIElement(UIElementId, false);
        }

        public void EndUIElement(uint UIElementId)
        {
            this.listBox1.Items.Clear();
        }

        #endregion
    }
}